#include <qthing>

#include "esp_log.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/semphr.h"


#include "SiliconTorch/FxCyanF.hpp"

#include <SpiderLib.hpp>


#include "SiliconTorch/NVSExplorer.hpp"

#include "SiliconTorch/SiliconTorch.hpp"

#include "SiliconTorch/Service/FxCyanF.hpp"
#include "SiliconTorch/Service/Service.hpp"
#include "SiliconTorch/Service/ServiceManager.hpp"





SiliconTorch::SiliconTorch* torch = NULL;

SiliconTorch::ServiceManager::Service* fxCyan = NULL;
SiliconTorch::ServiceManager::ServiceManager* mgr = NULL;




void device_main() {


  qthing::Config cfg;

  // Needed for packet parsing, animation rendering and stuff
  qthing::power_managment_max_power();



  torch = new SiliconTorch::SiliconTorch();

  return;

  SemaphoreHandle_t mutex000 = xSemaphoreCreateBinary();

  // Do it in another task do control stack size
  new SpiderLib::Util::LambdaTask([&]() {
    // Trigger singleton initialization
    SiliconTorch::NVSExplorer::NVSExplorer::instance();


    mgr = new SiliconTorch::ServiceManager::ServiceManager();


    xSemaphoreGive(mutex000);
  });

  xSemaphoreTake(mutex000, portMAX_DELAY);  // avoid races with MQTT subscriptions (TODO: do we lock with WLAN atm???)

  qthing::enable_wifi();
  return;





  /*


  SemaphoreHandle_t mutex = xSemaphoreCreateBinary();

  // Do it in another task do control stack size
  new SpiderLib::Util::LambdaTask([&]() {
    // Trigger singleton initialization
    SiliconTorch::NVSExplorer::NVSExplorer::instance();

    SiliconTorch::FxCyanF::configureFromNVS();

    xSemaphoreGive(mutex);
  });

  xSemaphoreTake(mutex, portMAX_DELAY);  // avoid races with MQTT subscriptions (TODO: do we lock with WLAN atm???)


  */


  qthing::enable_wifi();
  return;




  // #############################
  // ### CLC-Drucker init code ###
  // #############################


/*
  ctrl = new CyanLight::CyanLightControl(3);

  // TODO: As CyanLight:: -NameSpace is now gone we have to add the used GPIOs ourselfs if we ever want to use this snipped again…
  
  ctrl->setFrqRes(100, 19);


  for (u8 i = 0; i < 100; i++) {

    bool _f = i % 2 == 0;

    ctrl->setPWM(0,  _f      * 1.0f);
    ctrl->setPWM(2, (_f ^ 1) * 1.0f);

    vTaskDelay(50 / portTICK_PERIOD_MS);
  }


  ctrl->setPWM(0, 0.0f);
  ctrl->setPWM(1, 0.0f);
  ctrl->setPWM(2, 1.0f);


  qthing::enable_wifi();
  cfg.apply();

  return;
*/


  // ### end CLC-Drucker ###
  // #############################

}
